align 4
IDT_x86_32_Start dd 0
 IDT_x86_32_Size dd 2048





IDTx86_32_Default_Vector_Template:
                         dw 0x0000   ;code baseaddress loword
                         dw 0x0008   ;code selector (as defined by GDT)
                         dw 0x8E00   ;characteristics
                         dw 0x0000   ;code baseaddress hiword

IDTR_x86_32:
     dw 2047      ;IDT_Size-1
     dd 0         ;IDT start address






































IDT_x86_32__fixVectorTemplateEntrPoint:
 push eax
 push esi


 ;First take the address of the Vector Template:
 ;;
  mov esi,IDTx86_32_Default_Vector_Template

 ;Now take the address of the default
 ;dummy software ISR:
 ;;
  mov eax,dummy_Software_ISR_x86_32

 ;Copy the low word to the Interrupt Vector Template:
 ;;
  mov [esi],ax

 ;Copy the high word to the Interrupt Vector Template:
 ;;
  shr eax,16
  mov [esi+6],ax



 pop esi
 pop eax
ret































IDT_x86_32__createDefaultIDT:
 push eax


 ;Fix the vector template for our currently
 ;running kernel:
 ;;
  call IDT_x86_32__fixVectorTemplateEntrPoint


 ;Take the current address right after the kernel
 ;binary in memory, and place the start
 ;of the IDT there:
 ;;
  mov eax,[_KERN_END]
  mov dword[IDT_x86_32_Start],eax


 ;Add the desired size of the IDT:
 ;;
  add eax,[IDT_x86_32_Size]

 ;Take the opportunity to advance the
 ;kernel end mark:
 ;;
  mov [_KERN_END],eax


 ;Fix the pointer to the IDT in the IDTR:
 ;;
  mov eax,[IDT_x86_32_Start]
  mov [IDTR_x86_32+2],eax


 ;Fill all IDT entries with this default
 ;template:
 ;;
  call IDT_x86_32__fillWithDefaultTemplate


 ;Load the new IDT (interrupts should be
 ;already disabled at this point of course):
 ;;
  lidt [IDTR_x86_32]

 ;At this point we could enable interrupts, but
 ;we won't, until we install all of the proper
 ;IRQ handlers for the PIT Timer, the Keyboard
 ;and the FDC.
 ;;


 pop eax
ret










IDT_x86_32__fillWithDefaultTemplate:
 push ecx
 push esi
 push edi


 ;Take the default vector template start address:
 ;;
  mov esi,IDTx86_32_Default_Vector_Template


 ;Take the IDT start address:
 ;;
  mov edi,[IDT_x86_32_Start]


 ;Prepare to make 256 copies of it:
 ;;
  mov ecx,256


 ;Do the copy with the following simple loop:
 ;;
  align 4
  .l:

   ;Copy the template into the current IDT entry.
   ;Avoid advancing ESI so that we start fresh
   ;with the template's base address for each
   ;of the 256 iterations:
   ;;
    push esi
     movsd
     movsd
    pop esi

  dec ecx
  jnz .l





 pop edi
 pop esi
 pop ecx
ret


































;Inputs
;      AL == Interrupt Number
;     EBX == Entry point of our ISR
;;
 IDT_x86_32__InstallISR:
  push eax

  ;Take the interrupt number in EAX
  ;and preserve only the 8 lower bits:
  ;;
   and eax,11111111b

  ;Multiply this number to the size of
  ;a single IDT entry (8 bytes). With that
  ;we obtain the raw offset of the entry
  ;into the IDT:
  ;;
   shl eax,3

  ;Add to it the offset of the start of
  ;the IDT, so we can operate it:
  ;;
   add eax,[IDT_x86_32_Start]


  ;Now copy the low word of our ISR entry point:
  ;;
   mov [eax],bx

  ;And finally copy the high word of our ISR entry point:
  ;;
   ror ebx,16
   mov [eax+6],bx
   ror ebx,16     ;Leave EBX in its original state


  pop eax
 ret
