FD_executeFloppyDOR:
  push eax
  push ecx
  push edx
    mov dx, 03F2h
    mov al, cl
     out dx,al

   call FD_waitUntilReady

   mov ecx,500
   call PIT_8253_4__waitTickChanges
  pop edx
  pop ecx
  pop eax
          ret












































;Usage:
;     mov cl, driveLetter
;       call FD_recalibrate
;
FD_recalibrate:
  push eax
  push edx
     call FD_waitUntilReady
      mov dx,03F5h       ;command port
      mov al,00000111b   ;recalibrate command
       out dx,al

     call FD_waitUntilReady
      mov al,cl          ;user parameters
       out dx,al         ;send

     call FD_waitINT

  pop edx
  pop eax
           ret




























;Usage:
;      xor ecx,ecx
;      mov cl,driveSelect__headNum
;      mov ch,newCylinderNum
;         call FD_floppySeek
;
;This function returns nothing
FD_floppySeek:
 push eax
 push ecx
 push edx
   call FD_waitUntilReady
    mov dx, 03F5h
    mov al, 00001111b  ;command byte 0 (seek command)
     out dx,al         ;send

   call FD_waitUntilReady
    mov al, cl  ;command byte 1 (drive selection and head number)
     out dx,al

   call FD_waitUntilReady
    mov al,ch   ;command byte 2 (new cylinder number)
     out dx,al

   call FD_waitINT     ;wait interrupt

 pop edx
 pop ecx
 pop eax
              ret












































;Usage:
;      call FD_floppyVersion
;
;This command is specific to the FDC controller, NOT to any
;floppy drive at all.
;
;This function returns the version byte in AL
;
FD_floppyVersion:
 push ecx
 push edx
    xor eax,eax

    call FD_waitUntilReady
     mov al, 00010000b      ;controller version command
     mov dx, 03F5h          ;command port
     out dx, al             ;execute

     call FD_waitUntilReady   ;wait
      in al,dx                ;get version (result byte)
 pop edx
 pop ecx
                   ret





























FD_waitUntilReady:
 push eax
 push edx
  FD_waitUntilReady_l:
    mov dx,03F4h           ;main status register
    in al,dx               ;get status byte in AL
    test al,10000000b      ;see if *data register ready* byte is set
  jz FD_waitUntilReady_l   ;if not, do until set
 pop edx
 pop eax
              ret






































;Usage:
;     mov al,FDparams
;       call FD_out
FD_out:
  pusha
   call FD_waitUntilReady
     mov dx,03F5h
     out dx,al
  popa
          ret


































;Usage:
;       call FD_in
;
;It returns the byte in AL (EAX)
;
FD_in:
   call FD_waitUntilReady

  push edx
  xor eax,eax
   mov dx,03F5h
   in al,dx
  pop edx
      ret

