;This function reads the 9
;sectors of the FAT1, to make
;it simpler and faster (avoid
;moving the floppy head back
;and forth) reading the FAT
;entries, specially entries
;that are stored across
;2 sector boundaries, for
;every 2 sectors, which would
;complicate reading and joining
;2 different sectors to gather
;a complete FAT entry:
;;
createFATcache:
 push ebx
 push ecx
 push esi
 push edi


 ;Buffer for the whole FAT12
 ;table (9 sectors):
 ;;
;  mov edi,FAT12_FAT
  mov edi,[FAT12_FAT_Start]



 ;EBX = LBA sector of start of FAT 1
 ;      (sector 1)
 ;
 ;;
  mov ebx,FAT12_FAT1_LBA_start


 ;FAT sector count (9 sectors):
 ;;
  mov ecx,FAT12_FAT1_LBA_sectorCount


  

  .l:

    ;Read the sector:
    ;;
     call FDC_readSector_LBAFloppyA_1_44

    ;Copy sector, from its internal
    ;software DMA buffer, to our
    ;FAT cache "heap" space:
    ;;
     push ecx
;      xor esi,esi        ;sourceMem
;;     mov esi,Floppy_Sector_Cache        ;sourceMem
   mov esi,[Floppy_Sector_Cache_Start]

     ;mov edi,FAT12_FAT  ;destinMem
      mov cx,512         ;memLength
       call kmemcpy
       add edi,ecx  ;Advance "heap" pointer

     pop ecx


    ;Read next sector
    ;;
     inc ebx
  dec ecx
  jnz .l


 pop esi
 pop esi
 pop ecx
 pop ebx
ret
