;Inputs:
;        ESI == string containing "byte", "word"
;               or "dword"
;
;Outputs:
;        EAX == bit mask with 8, 16 or 32 bits set
;               to 1, starting from the lowest bit.
;               If it isn't "byte", "word" or "dword",
;               (or "qword" for possible 64-bit versions)
;               EAX will have a value of 0.
;;
sys_arg2numwidth:
 push ecx
 push edi


 ;Test for "byte"
 ;See if both strings are of the same size:
 ;;
  mov edi,str_byte
  call mem__ASCIIZ_compare_lengths
  cmp eax,0
  jne .isnotbyte


 ;Now see if the string is "byte":
 ;;
  call mem__compareBuffer
  cmp eax,0
  jne .isnotbyte



    mov eax,11111111b
    jmp .END

  .isnotbyte:




 ;Test for "word"
 ;See if both strings are of the same size:
 ;;
  mov edi,str_word
  call mem__ASCIIZ_compare_lengths
  cmp eax,0
  jne .isnotword


 ;Now see if the string is "word":
 ;;
  call mem__compareBuffer
  cmp eax,0
  jne .isnotword




    mov eax,1111111111111111b
    jmp .END

  .isnotword:



 ;Test for "dword"
 ;See if both strings are of the same size:
 ;;
  mov edi,str_dword
  call mem__ASCIIZ_compare_lengths
  cmp eax,0
  jne .isnotdword


 ;Now see if the string is "dword":
 ;;
  call mem__compareBuffer
  cmp eax,0
  jne .isnotdword

    mov eax,11111111111111111111111111111111b
    jmp .END

  .isnotdword:


  ;If we are here, an invalid size
  ;was specified:
  ;;
   xor eax,eax




 .END:

 pop edi
 pop ecx
ret
