 console_execute_command_line:
  pusha

  ;Assume there are no parameters in this command line:
  ;;
   mov dword[console_command_params_ptr],ecx


  ;Move the cursor/screen:
  ;;
   call console_doCRLFeffect





  ;Take the size of the command line:
  ;;
   mov ecx,[console_command_line_idx]



  ;If the command line is empty, end:
  ;;
   cmp ecx,0
   je .END



  ;If the command line is not empty, search
  ;for the nearest blank space. This is the
  ;simplest way to separate the program name
  ;from its command line, assuming the program
  ;name doesn't have blank spaces and is not quoted:
  ;;
  ;Find the position of the first blank space in the
  ;command string:
  ;;
   ;     ESI == Pointer to string
   ;     ECX == Maximum number of bytes to search
   ;      AL == Nearest occurrence of this byte value to search
   ;
   ;Outputs:
   ;     ESI == Value of nearest occurrence, if found
   ;;
     mov esi,console_command_line
     mov edi,esi
     mov ecx,[console_command_line_idx]
     mov al,' '
      call KernString_find_nearest_byte

    ;Now ESI has either not changed (no blank spaces)
    ;or now it contains the offset of the new blank
    ;space. So what we will do is take this ESI, substract
    ;the base address of the command line in the kernel
    ;image (to get a raw offset of either the original
    ;end of the command line or the raw offset of the first
    ;blank space), and put it in ECX.
    ;
    ;Note how we alter the copy of the command line index
    ;in ECX but not the actual index variable. This allows us
    ;to later retrieve the next of the command line, and at
    ;the same time, use the copy of the index in ECX to
    ;search only for the command name.
    ;
    ;Note also that this part of the code doesn't affect the
    ;code that searches external FAT command names, below,
    ;since that code inconditionally pads the command line
    ;with blank spaces, and searches for a fixed-length file name
    ;of 11 binary bytes.
    ;
    ;However, we will have to improve that very thing, avoiding
    ;that code from overwriting the original command line, and
    ;making an 11-byte copy of it, and filling that one with
    ;zeroes, to make it possible to pass parameters to external
    ;programs too. We will also probably need some sort of PSP
    ;to properly pass "environment" and command line address/size
    ;to the external program.
    ;;
     ;See if the command line offset was altered.
     ;If not, avoid manipulating it since it means
     ;that no blank space was found in the range of
     ;our current command line string:
      cmp esi,edi
      je .noCmdLineParams
       sub esi,console_command_line
       mov ecx,esi

      .noCmdLineParams:

      ;Record where in the command line
      ;the actual parameters start:
      ;;
       mov dword[console_command_params_ptr],ecx
       add dword[console_command_params_ptr],console_command_line



  ;Take the number of internal commands:
  ;;
   xor ebx,ebx


  ;Take the start of the command line:
  ;;
   mov esi,console_command_line


  ;Take the start of the commands table:
  ;;
   mov edi,_console_command_strings



  ;Iterate the command strings table to search
  ;for a command string that matches with our
  ;command line:
  ;;
   .l:

     call console_compare_strings


    ;If we found the command, call its
    ;corresponding function:
    ;;
     cmp eax,1
     jne .noMatch

       ;Take the start of the entry points table:
       ;;
        mov eax,_console_command_entrypoints

       ;Multiply EBX, the number of the command,
       ;from 0 to N, by 4, to convert it to a
       ;DWORD offset into the table:
       ;;
        shl ebx,2

       ;Add the base address and the offset together:
       ;;
        add eax,ebx

       ;Call the function:
       ;;
        call [eax]


;       call clrscr
        jmp .emptyCmdLine

     .noMatch:


    ;Go to next command line string:
    ;;
     mov edi,edx

   inc ebx
   cmp ebx,[_console_num_commands]
   jb .l










     ;;;INIT: If the command was not found, search it as external floppy file
     ;;;INIT: If the command was not found, search it as external floppy file
     ;;;INIT: If the command was not found, search it as external floppy file
     ;;;INIT: If the command was not found, search it as external floppy file
     ;;;INIT: If the command was not found, search it as external floppy file

       ;Make a copy of the first 11 bytes of the program name:
       ;;
        ;ESI == Source
        ;EDI == Destination
        ;ECX == Number of bytes
        ;;
         push ecx
         push esi
         push edi
          mov esi,console_command_line
          mov edi,FAT_SFN
          mov ecx,11
          call kmemcpy
         pop edi
         pop esi
         pop ecx




      ;See if the command line is lower than 11 characters.
      ;If so, pad the end of this string
      ;;
       cmp dword[console_command_line_idx],11
       jae ._8_3_prospect_name_full

        ;Take the current index:
        ;;
         mov edi,[console_command_line_idx]




;   ;     ESI == Pointer to string
;   ;     ECX == Maximum number of bytes to search
;   ;      AL == Nearest occurrence of this byte value to search
;   ;
;   ;Outputs:
;   ;     ESI == Value of nearest occurrence, if found
;   ;;
;     push eax
;     push ecx
;     push esi
;     mov esi,console_command_line
;     mov edi,esi
;     mov ecx,[console_command_line_idx]
;     mov al,' '
;      call KernString_find_nearest_byte
;
;
;     ;See if the command line offset was altered.
;     ;If not, avoid manipulating it since it means
;     ;that no blank space was found in the range of
;     ;our current command line string:
;      cmp esi,edi
;      je .noCmdLineParams1
;       sub esi,console_command_line
;       mov edi,esi
;
;      .noCmdLineParams1:
;
;     pop esi
;     pop ecx
;     pop eax







        ;Set the limit to 11 characters:
        ;;
         mov ecx,11

        ;Substract 11-cmdbuff_idx to know
        ;how many characters are left to
        ;reach 11 characters with padding:
        ;;
         sub ecx,edi

        ;Now set EDI to the end of the
        ;effective buffer, to pad it
        ;with regular blank spaces until
        ;we reach 11 characters for the
        ;8.3 raw file name:
        ;;
         add edi,FAT_SFN
         mov eax," "
         rep stosb

       ._8_3_prospect_name_full:











        ;Take the command line buffer as the raw
        ;8.3 file name, and attempt to read/execute it:
        ;;
         mov esi,FAT_SFN
         call FAT12_execExternalProgram




         ;Update the index of the command line buffer
         ;to reflect its new size (ATTENTION: make sure
         ;this is correct, and if it shouldn't be N-1
         ;because here it is 11 actually):
         ;
         ;NOTE: THIS THING, SPECIALLY SETTING THE FIRST BYTE
         ;      OF THE COMMAND LINE TO 0, PREVENTS FROM RUNNING
         ;      THE LAST SUCCESSFUL EXTERNAL PROGRAM IS AN UNKNOWN
         ;      COMMAND IS ENTERED, BUT EXACTLY WHY????
         ;
         ;      TRACE IT TO WRITE AN INSTRUCTIVE HISTORY ABOUT THAT!!!
         ;;
          mov byte[console_command_line],0
          mov dword[console_command_line_idx],0







        ;If EAX is 0, it means that we didn't find any
        ;external program file with a name that matches,
        ;the command line, and thus we must report that:
        ;;
         cmp eax,0
         je .noSuchInternal__noSuchFloppy


         ;If we jump through this, that means that we successfuly
         ;found an external program:
         ;;
          jmp .temporary_Kproc_END

     ;;;END:  If the command was not found, search it as external floppy file
     ;;;END:  If the command was not found, search it as external floppy file
     ;;;END:  If the command was not found, search it as external floppy file
     ;;;END:  If the command was not found, search it as external floppy file
     ;;;END:  If the command was not found, search it as external floppy file


  .noSuchInternal__noSuchFloppy:

   mov esi,STR_CmdNotFound
    call console_kprint_visible
    call console_doCRLFeffect





  .temporary_Kproc_END:
  .emptyCmdLine:



  ;Empty the command line:
  ;;
   mov dword[console_command_line_idx],0


  .END:

  popa
 ret












;Inputs:
;      ECX == Size of the actual command line command
;             (might be the full command line, the first
;             blank space, or the first blank space after
;             a quoted command name). By now this simple
;             implementation would take the full command line:
;
;      ESI == Start of user's command line
;
;      EDI == Start of current command string
;
;Outputs:
;      EDX == Offset of possible next command string,
;             to use in replacement of old EDI.
;
;      EAX == 1 if the current string matched; 0 otherwise.
;
;;
 console_compare_strings:
  push ecx
  push esi
  push edi


  ;Assume that there is no match:
  ;;
   xor eax,eax


  .l:

   ;Compare the byte of both 
   ;;
    cmpsb

   ;See if they match:
   ;;
    jne .noMatch



  dec ecx
  jnz .l

   ;If there was something after a null byte
   ;in the command table's current command string,
   ;it means that the command line was shorter than
   ;it, and cannot possibly match.
   ;
   ;This should be a more efficient alternative than
   ;using strcmp, or strlen on both the command line
   ;and the current command string, as it is just
   ;2 instructions and the loop sequence above:
   ;;
    cmp byte[edi],0
    jne .noMatch


   ;If we are here, it means that
   ;all characters matched, and that there was
   ;no unchecked characters (no string length difference)
   ;and we will report that:
   ;;
    mov eax,1
    jmp .END



 .noMatch:


   ;At this point, regardless of a string
   ;match or not, we are at either the null
   ;byte position of this string, or some
   ;character of the current command string,
   ;so we must position ourselves in the null
   ;character of the current string (if we are
   ;not there, or otherwise it will have no
   ;practical effect):
   ;;
    .look0:
      ;See if the current character is null.
      ;If so, everything is ready:
      ;;
       cmp byte[edi],0
       je .END

      ;If not, advance the string pointer
      ;and keep looping (until we find a null char):
      ;;
       inc edi
     jmp .look0



 .END:


  ;Find the position of the next ASCIIZ
  ;command string:
  ;;

   ;At this point we are already at the null
   ;byte of the current command string, so we
   ;just need to increment it in 1 to point to
   ;the next command string:
   ;;
    inc edi

   ;Return the actual physical location of the
   ;next command string in the table:
   ;;
    mov edx,edi

  pop edi
  pop esi
  pop ecx
 ret







align 4
FAT_SFN times 12 db 0