;This function puts an ASCII character in the
;command line, as long as there is still space
;in it, and prints it in the screen.
;
;Inputs:
;      AL == ASCII value
;;
 console__put_cmdline_ASCII_char:
  push eax
  push ebx
  push edi


   ;See if the command line is already full.
   ;If so, end, discarding the byte:
   ;;
    cmp dword[console_command_line_idx],CONS_CMDLINE_LIMIT
    jae .cmdline_full


     ;Put the text attribute byte:
     ;;
      mov ah,7



     ;If there is space available in the command line,
     ;get the first free byte position of the command line
     ;and write the specified byte:
     ;;
      mov edi,console_command_line
      add edi,[console_command_line_idx]
      stosb

     ;Update the free position of the command line:
     ;;
      inc dword[console_command_line_idx]


     ;Avoid writing beyond the visible screen:
     ;;
      cmp dword[console_ptr],0xB8000+4000
      jae .screenFull


     ;Write the character in the text screen
     ;and update/advance it:
     ;;
      mov edi,[console_ptr]
      stosw
      add dword[console_ptr],2



     ;Take the current offset of the
     ;on-screen buffer to see if we
     ;are over the limit in which we
     ;should perform a (software) scrolling
     ;of the screen:
     ;;
      push edx
        mov edx,[console_ptr]
        call console_scroll_update
      pop edx




     ;Update the text hardware position:
     ;;
      mov ebx,[console_ptr]     ;Take the current position
      sub ebx,0xB8000           ;Remove the frame buffer value
      shr ebx,1                 ;Divide by 2 (to get rid of size of attribute bytes)
     ;inc ebx                   ;Add 1 to put cursor right after last command line char
                                ;NOTE: We commented this out because it was fixed for this
                                ;      effect by the time we updated the screen console ptr,
                                ;      'console_ptr'
       call VGAVideo_CRTC_setTextCurPos


    .cmdline_full:

    .screenFull:

  pop edi
  pop ebx
  pop eax
 ret














;This function erases an ASCII character from the
;command line, as long as there is something
;in it, and erases it from the screen.
;
;;
console_erase_char:
  push ebx
  push edi

   ;See if the command line is empty.
   ;If so, end, avoiding to erase non-existing chars:
   ;;
    cmp dword[console_command_line_idx],0
    je .cmdline_empty

     ;If there is something inside the command line,
     ;get the last non-free byte position of the command line
     ;and write a null byte:
     ;;
      mov edi,console_command_line
      add edi,[console_command_line_idx]
      mov byte[edi],0

     ;Update the free position of the command line:
     ;;
      dec dword[console_command_line_idx]


     ;Write the character in the text screen
     ;and update/advance it:
     ;;
      mov edi,[console_ptr]
      sub edi,2
      mov byte[edi],' '
      mov dword[console_ptr],edi


     ;Update the text hardware position:
     ;;
      mov ebx,[console_ptr]     ;Take the current position
      sub ebx,0xB8000           ;Remove the frame buffer value
      shr ebx,1                 ;Divide by 2 (to get rid of size of attribute bytes)
     ;dec ebx                   ;Substract 1 to put cursor right after last command line char
                                ;NOTE: We commented this out because it was fixed for this
                                ;      effect by the time we updated the screen console ptr,
                                ;      'console_ptr'
       call VGAVideo_CRTC_setTextCurPos


    .cmdline_empty:

  pop edi
  pop ebx
ret














;Inputs:
;       EDX == Value to test and for which, if
;              greater than the physical address
;              of the visible screen pointer,
;              will cause a software scroll effect
;              of the text screen, in 1 line.
;
;;
console_scroll_update:
   pusha


;    cmp dword[console_ptr],edx        ;0xB8000+4000
    cmp edx,0xB8000+4000
    jb .noScroll

      mov dword[console_ptr],0xB8000+4000-160
      mov esi,0xB8000+160
      mov edi,0xB8000
      mov ecx,(4000-160)/4
      rep movsd

      mov esi,0xB8000+4000-160
      mov eax,0x07200720
      mov ecx,160
      rep stosd


    .noScroll:



   popa
ret

