;This function prints text only in the visible
;text screen range.
;
;Inputs:
;      ESI == ASCIIZ string to print
;
;;
 console_kprint_visible:
  push eax
  push esi
  push edi

  mov edi,[console_ptr]

  ;Avoid writing beyond the visible screen:
  ;;
   cmp edi,0xB8000+4000
   jae .END



  ;Place the attribute byte:
  ;;
   mov ah,7


    .l:
     lodsb
     cmp al,0
     je .l_END

     ;If we have reached a screen
     ;position beyond of the visible
     ;screen, break this loop to avoid
     ;overwriting unintended memory:
     ;;
      cmp edi,0xB8000+4000
      jae .l_END

     stosw


    jmp .l
    .l_END:


  ;Update the screen pointer:
  ;;
   mov dword[console_ptr],edi



  ;Update the text screen hardware cursor:
  ;;
   push ebx
    mov ebx,edi
    sub ebx,0xB8000
    shr ebx,1
    call VGAVideo_CRTC_setTextCurPos
   pop ebx



  .END:

  pop edi
  pop esi
  pop eax
 ret
