;Inputs:
;       ESI == source buffer
;       EDI == destination buffer
;       ECX == buffer size
;
;Outputs:
;        EAX == 0 if buffers are identical
;               nonzero if buffers are different
;;
mem__compareBuffer:
 push ebx
 push ecx
 push esi
 push edi


  xor eax,eax



;   repe cmpsb



       .l:

           mov bl,[esi]
           cmp byte bl,[edi]
           jne .l__END



        inc esi
        inc edi

       dec ecx
       jnz .l
       .l__END:



  cmp ecx,0
  je .identical

    inc eax


 .identical:


 pop edi
 pop esi
 pop ecx
 pop ebx
ret









;Inputs:
;       ESI == ASCIIZ string
;
;Outputs:
;       EAX == string length, discounting the
;              (first found) null byte
;;
mem__ASCIIZ_length:
 push esi


  xor eax,eax

  .l:

     cmp byte[esi],0
     je .l__END

     inc esi
     inc eax


  jmp .l
  .l__END:




 pop esi
ret













;Inputs:
;       ESI == string 1
;       EDI == string 2
;
;Outputs:
;        EAX == 0 if lengths are the same
;               nonzero if lengths are different
;;
mem__ASCIIZ_compare_lengths:
 push ebx
 push ecx


 ;Check the length of the first string
 ;and save it:
 ;;
  call mem__ASCIIZ_length
  mov ebx,eax


 ;Check the length of the second string
 ;and save it:
 ;;
  xchg esi,edi
    call mem__ASCIIZ_length
    mov ecx,eax
  xchg esi,edi


 ;Clear our result variable, assuming that
 ;lengths match:
 ;;
  xor eax,eax


 ;See if the lengths of both strings match
 ;and mark our result variable accordingly:
 ;;
  cmp ebx,ecx
  je .equallength

    inc eax

  .equallength:




 pop ecx
 pop ebx
ret

















