;Inputs:
;       ESI == Program's import table, in which
;              the first wideword is the number of widewords
;              in the table, with the reference number of
;              the functions to import.
;
;This function converts the reference numbers of  the kernel
;functions into the addresses of their entry points. It's useful
;to keep a per-application import table, to call directly the
;entry points of the kernel functions, similar to calling WinAPI
;functions, without the hassle of making it too difficult to pass
;register/stack parameters if we were to call a much less efficient
;wrapper function that in turn called an imported function.
;
;;
resolveFunctionReferences:
 ;If the pointer to our application's import table is a null
 ;pointer, then we must not do anything (applications doesn't
 ;import any kernel functions):
 ;;
  cmp esi,0
  je .END




 push eax
 push ecx
 push esi



  ;Take the count of elements in this import table:
  ;;
   mov ecx,[esi]


  ;Advance ESI to start reading the actual table entries:
  ;;
   add esi,4


 ;Loop through all of the entries in the specified imports table:
 ;;
  .l:

    ;Take the current entry's reference number:
    ;;
     mov eax,[esi]


    ;Convert it to its corresponding entry point address:
    ;;
     call APP__loadlib_symbolRef2entrypoint


    ;Replace the reference number with this entry point address:
    ;;
     mov [esi],eax


    ;Go to the next import table's entry:
    ;;
     add esi,4

  dec ecx
  jnz .l



 pop esi
 pop ecx
 pop eax


 .END:
ret
